import a from "../../function/isFunction/index.es.js";
class r {
  _value;
  constructor(t, o) {
    if (t === void 0 || o === void 0)
      throw Error("Pair: Both first and second values must be defined");
    this._value = [t, o];
  }
  static of(t) {
    return new r(t, t);
  }
  // @ts-ignore
  of(t) {
    return new r(t, t);
  }
  equals(t) {
    return t.fst() === this.fst() && t.snd() === this.snd();
  }
  concat(t) {
    if (!(t instanceof r)) throw Error("Pair: Pair required");
    const o = this.fst(), n = this.snd(), s = t.fst(), e = t.snd();
    if (!o.concat || !n.concat || !s.concat || !e.concat)
      throw Error("Pair: Both Pairs must contain Semigroups");
    return new r(o.concat(s), n.concat(e));
  }
  fst() {
    return this.getValue()[0];
  }
  snd() {
    return this.getValue()[1];
  }
  // @ts-ignore
  ap(t) {
    if (!(t instanceof r)) throw Error("Pair: Pair required");
    const o = this.snd();
    if (!a(o))
      throw Error("Pair: Second wrapped value should be a function");
    const n = this.fst(), s = t.fst();
    if (!n.concat || !s.concat)
      throw Error("Pair: Types should be Semigroups");
    return new r(n.concat(s), o(s));
  }
  getValue() {
    return this._value;
  }
  map(t) {
    if (!a(t)) throw Error("Pair: Expected a function");
    return new r(this.fst(), t(this.snd()));
  }
  bimap(t, o) {
    if (!a(t) || !a(o))
      throw Error("Pair: Expected functions for both parts");
    return new r(t(this.fst()), o(this.snd()));
  }
  // @ts-ignore
  chain(t) {
    if (!a(t)) throw Error("Pair: Expected a function");
    const o = this.fst();
    if (!o.concat) throw Error("Pair: First value should be a Semigroup");
    const n = t(this.snd());
    if (!(n instanceof r))
      throw Error("Pair: Function must return a Pair");
    const s = n.fst();
    if (!s.concat)
      throw Error(
        "Pair: First value of the returned Pair should be a Semigroup"
      );
    return new r(o.concat(s), n.snd());
  }
  swap() {
    const t = this.getValue();
    return new r(t[1], t[0]);
  }
  toString() {
    const t = this.getValue();
    return `Pair((${t[0]}), (${t[1]}))`;
  }
}
r.prototype["fantasy-land/equals"] = r.prototype.equals;
r.prototype["fantasy-land/map"] = r.prototype.map;
r.prototype["fantasy-land/concat"] = r.prototype.concat;
r.prototype["fantasy-land/bimap"] = r.prototype.bimap;
r.prototype["fantasy-land/chain"] = r.prototype.chain;
r.prototype["fantasy-land/of"] = r.prototype.of;
r.prototype["fantasy-land/ap"] = r.prototype.ap;
export {
  r as default
};
//# sourceMappingURL=pair-type.es.js.map
