import { default as Monad } from '../../interface/Monad';
import { default as Semigroup } from '../../interface/Semigroup';
import { default as Setoid } from '../../interface/Setoid';
declare class Identity<A> implements Setoid, Semigroup, Monad<A> {
    private _value;
    constructor(value: A);
    static of<C>(v: C): Identity<C>;
    of<C>(v: C): Identity<C>;
    getValue(): A;
    equals(j: Identity<A>): boolean;
    concat(i: Identity<Semigroup>): Identity<A>;
    ap<B, C>(i: Identity<B>): Identity<C>;
    map<B>(f: (a: A) => B): Identity<B>;
    chain<B>(f: (a: A) => Identity<B>): Identity<B>;
    toString(): string;
}
export default Identity;


declare namespace State {
    var of: <C, D>(v: C) => StateType<unknown, unknown>;
    var get: (fn?: Function) => StateType<any, any>;
    var put: (s: any) => StateType<any, any>;
}


declare namespace Reader {
    var of: <C>(v: C) => ReaderType<unknown, unknown>;
    var ask: (fn?: Function) => ReaderType<any, any>;
}


declare namespace Pair {
    var of: <C>(v: C) => PairType<C, C>;
}


declare namespace Identity {
    var of: <C>(v: C) => IdentityType<C>;
}
