import { default as BiFunctor } from '../../interface/Bifunctor';
import { default as Monad } from '../../interface/Monad';
import { default as Semigroup } from '../../interface/Semigroup';
import { default as Setoid } from '../../interface/Setoid';
declare class Pair<A, B> implements Setoid, Semigroup, BiFunctor<A, B>, Monad<B> {
    private _value;
    constructor(v1: A, v2: B);
    static of<C>(v: C): Pair<C, C>;
    of<C>(v: C): Pair<C, C>;
    equals(j: Pair<A, B>): boolean;
    concat(p: Pair<Semigroup, Semigroup>): Pair<A, B>;
    fst(): A;
    snd(): B;
    ap<C, D>(j: Pair<C, B>): Pair<C, D>;
    getValue(): (A | B)[];
    map<C>(f: (a: B) => C): Pair<A, C>;
    bimap<C, D>(f1: (a: A) => C, f2: (a: B) => D): Pair<C, D>;
    chain<C, D>(f: (a: B) => Pair<C, D>): Pair<C, D>;
    swap(): Pair<A | B, A | B>;
    toString(): string;
}
export default Pair;


declare namespace State {
    var of: <C, D>(v: C) => StateType<unknown, unknown>;
    var get: (fn?: Function) => StateType<any, any>;
    var put: (s: any) => StateType<any, any>;
}


declare namespace Reader {
    var of: <C>(v: C) => ReaderType<unknown, unknown>;
    var ask: (fn?: Function) => ReaderType<any, any>;
}


declare namespace Pair {
    var of: <C>(v: C) => PairType<C, C>;
}


declare namespace Identity {
    var of: <C>(v: C) => IdentityType<C>;
}
