import { default as Monad } from '../../interface/Monad';
declare class Reader<A, B> implements Monad<B> {
    private _value;
    constructor(fn: Function);
    static of<C>(v: C): Reader<unknown, unknown>;
    of<C>(v: C): Reader<unknown, unknown>;
    ask(fn?: Function): Reader<A, B>;
    runWith(ctx: A): any;
    ap<C, D>(j: Reader<C, B>): Reader<C, D>;
    getValue(): Function;
    map<C>(f: Function): Reader<A, C>;
    chain<C, D>(f: (a: B) => Reader<C, D>): Reader<C, D>;
    toString(): string;
}
export default Reader;


declare namespace State {
    var of: <C, D>(v: C) => StateType<unknown, unknown>;
    var get: (fn?: Function) => StateType<any, any>;
    var put: (s: any) => StateType<any, any>;
}


declare namespace Reader {
    var of: <C>(v: C) => ReaderType<unknown, unknown>;
    var ask: (fn?: Function) => ReaderType<any, any>;
}


declare namespace Pair {
    var of: <C>(v: C) => PairType<C, C>;
}


declare namespace Identity {
    var of: <C>(v: C) => IdentityType<C>;
}
