import { default as Monad } from '../../interface/Monad';
declare class State<A, B> implements Monad<B> {
    private _value;
    constructor(fn: Function);
    static of<G, K>(v: G): State<unknown, unknown>;
    of<C, D>(v: C): State<unknown, unknown>;
    get(fn?: Function): State<A, B>;
    put(s: B): State<A, B>;
    runWith(s: A): any;
    execWith(s: A): any;
    evalWith(s: A): any;
    ap<C, D>(j: State<C, (b: B) => D>): State<C, D>;
    getValue(): Function;
    map<C>(f: Function): State<A, C>;
    chain<C, D>(f: (a: B) => State<C, D>): State<C, D>;
    toString(): string;
}
export default State;


declare namespace State {
    var of: <C, D>(v: C) => StateType<unknown, unknown>;
    var get: (fn?: Function) => StateType<any, any>;
    var put: (s: any) => StateType<any, any>;
}


declare namespace Reader {
    var of: <C>(v: C) => ReaderType<unknown, unknown>;
    var ask: (fn?: Function) => ReaderType<any, any>;
}


declare namespace Pair {
    var of: <C>(v: C) => PairType<C, C>;
}


declare namespace Identity {
    var of: <C>(v: C) => IdentityType<C>;
}
