import { default as Monad } from '../../interface/Monad';
import { default as Semigroup } from '../../interface/Semigroup';
declare class Task implements Semigroup, Monad<(rej: Function, res: Function) => any> {
    private _value;
    constructor(f: (rej: Function, res: Function) => any);
    static of(v: any): Task;
    static rejected(v: any): Task;
    of(v: any): Task;
    rejected(v: any): Task;
    fork(reject: Function, resolve: Function): void;
    toString(): string;
    map<A, B>(f: (a: A) => B): Task;
    getValue(): (rej: Function, res: Function) => any;
    ap(t: Task): Task;
    concat(t: Task): Task;
    chain(f: Function): Task;
    toPromise(): Promise<unknown>;
}
export default Task;


declare namespace State {
    var of: <C, D>(v: C) => StateType<unknown, unknown>;
    var get: (fn?: Function) => StateType<any, any>;
    var put: (s: any) => StateType<any, any>;
}


declare namespace Reader {
    var of: <C>(v: C) => ReaderType<unknown, unknown>;
    var ask: (fn?: Function) => ReaderType<any, any>;
}


declare namespace Pair {
    var of: <C>(v: C) => PairType<C, C>;
}


declare namespace Identity {
    var of: <C>(v: C) => IdentityType<C>;
}
